unit FrameWin;  {this unit is copied from a portion of a gpc demo}
interface
uses CRT;

{-------------from demo-------------------------------}
type
  TFrameChars = array [1 .. 8] of Char;
const
  SingleFrame : TFrameChars = (chCornerTLS, chLineHS, chCornerTRS, chLineVS,
                               chLineVS, chCornerBLS, chLineHS, chCornerBRS);
  DoubleFrame : TFrameChars = (chCornerTLD, chLineHD, chCornerTRD, chLineVD,
                               chLineVD, chCornerBLD, chLineHD, chCornerBRD);


  procedure FrameWin( const Title: string; const Frame: TFrameChars);

implementation

var
  ScrollState : Boolean = True;
  CursorShape : TCursorShape = CursorNormal;

procedure FrameWin (const Title : String; const Frame : TFrameChars);
var
  w, h, y : Integer;
  PCCharSetSave : Boolean;
begin
  w := GetXMax;
  h := GetYMax;
  SetPCCharSet ( true );
  WriteCharAt (1, 1, 1,     Frame [1], TextAttr);
  WriteCharAt (2, 1, w - 2, Frame [2], TextAttr);
  WriteCharAt (w, 1, 1,     Frame [3], TextAttr);
  for y := 2 to h - 1 do
    begin
      WriteCharAt (1, y, 1, Frame [4], TextAttr);
      WriteCharAt (w, y, 1, Frame [5], TextAttr)
    end;
  WriteCharAt (1, h, 1,     Frame [6], TextAttr);
  WriteCharAt (2, h, w - 2, Frame [7], TextAttr);
  WriteCharAt (w, h, 1,     Frame [8], TextAttr);
  SetPCCharSet ( false );
  WriteStrAt ((w - Length (Title)) div 2 + 1, 1, Title, TextAttr);
  Inc (WindowMin.X);
  Inc (WindowMin.Y);
  Dec (WindowMax.X);
  Dec (WindowMax.Y);
  GotoXY (1, 1);
end;
{-------------end from demo-------------------------}

end.
